package ru.cft.task.restClient;

import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.MenuItem;
import javafx.stage.Modality;
import javafx.stage.Stage;

import java.io.IOException;

public class MainController {

    private Stage mainStage;

    public void setMainApp(Stage mainStage) {
        this.mainStage = mainStage;
    }

    public Stage getMainApp() {
        return this.mainStage;
    }

    @FXML
    private MenuItem srv_config;
    @FXML
    private MenuItem create;
    @FXML
    private MenuItem read;
    @FXML
    private MenuItem update;
    @FXML
    private MenuItem delete;

    public void quitApp() {
        System.exit(0);
    }

    private Stage showModal(String fxml, String title) {
        Stage stage = null;
        try {
            Scene scene = new Scene(FXMLLoader.load(getClass().getResource(fxml)));
            stage = new Stage();
            stage.setScene(scene);
            stage.setResizable(false);
            stage.centerOnScreen();
            stage.setTitle(title);
            stage.initOwner(mainStage);
            stage.initModality(Modality.APPLICATION_MODAL);
            return stage;
        } catch (IOException e) {
            Utils.showAlert("error", e.getMessage());
        } finally {
            return stage;
        }
    }

    public void showServerConfig() {
        Stage config = showModal("/config.fxml", srv_config.getText());
        config.showAndWait();
    }

    public void createAction() {
        Stage cr = showModal("/form.fxml", create.getText());
        cr.showAndWait();
    }

    public void readAction() {
        Stage rd = showModal("/form.fxml", read.getText());
        rd.showAndWait();
    }

    public void updateAction() {
        Stage upd = showModal("/form.fxml", update.getText());
        upd.showAndWait();
    }

    public void deleteAction() {
        Stage dlt = showModal("/form.fxml", delete.getText());
        dlt.showAndWait();
    }
}